VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "RichEdit control Edit context menu demo"
   ClientHeight    =   3600
   ClientLeft      =   3045
   ClientTop       =   3240
   ClientWidth     =   6600
   ClipControls    =   0   'False
   Height          =   4290
   Left            =   2985
   LinkTopic       =   "Form1"
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   440
   Top             =   2610
   Width           =   6720
   Begin VB.Timer tmrWordBreakProc 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   5760
      Top             =   2970
   End
   Begin RichtextLib.RichTextBox Rich1 
      Height          =   2145
      Left            =   600
      TabIndex        =   0
      Top             =   360
      Width           =   5115
      _Version        =   65536
      _ExtentX        =   9022
      _ExtentY        =   3784
      _StockProps     =   69
      BackColor       =   -2147483643
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ScrollBars      =   3
      TextRTF         =   $"Context.frx":0000
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditUndo 
         Caption         =   "&Undo"
      End
      Begin VB.Menu mnuEditSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditCut 
         Caption         =   "Cu&t"
      End
      Begin VB.Menu mnuEditCopy 
         Caption         =   "&Copy"
      End
      Begin VB.Menu mnuEditPaste 
         Caption         =   "&Paste"
      End
      Begin VB.Menu mnuEditDelete 
         Caption         =   "&Delete"
      End
      Begin VB.Menu mnuEditSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditSelAll 
         Caption         =   "Select &All"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim m_hwndEdit As Long
 

Private Sub Form_Load()
  
  ' We'll use this property a lot,
  ' so we'll access it just once...
  m_hwndEdit = Rich1.hwnd

  ' Rich1's only default property that was changed in
  ' it's Properties window (is read-only of course...)
  'Rich1.ScrollBars = rtfBoth
  
  ' No shortcut key text until the context menu is shown & hidden
  SetEditMenuItemText False

  ' Add some text to Rich1
  Rich1 = GetIntroText
  
  KeyPreview = True   ' Form_KeyDown
  ScaleMode = vbPixels   ' Form_KeyDown PopupMenu pos
  Move (Screen.Width - Width) * 0.5, (Screen.Height - Height) * 0.5
  
End Sub

Private Function GetIntroText() As String
  Dim sText As String
  
  sText = "Demonstates extended edit context menu functionality..." & vbCrLf & vbCrLf
  
  sText = sText & "- Uses the Edit menu as the right-click context menu." & vbCrLf & vbCrLf
  
  sText = sText & "- The RichEdit control processes edit accelerator keys but does" & vbCrLf & _
                           "  not display a corresponding right-click edit context menu (?)," & vbCrLf & _
                           "  so NO shortcut keys are defined for the following cmds:" & vbCrLf & _
                           "  Undo, Cut, Copy, Paste, Delete & Select All." & vbCrLf & vbCrLf & _
                           "- All shortcut key strings are added and removed appropriately." & vbCrLf & vbCrLf
  
  sText = sText & "- If the mouse is currently inside the client area of the RichEdit" & vbCrLf & _
                           "  control, Shift+F10 displays the context menu at the mouse" & vbCrLf & _
                           "  position within the RichEdit control." & vbCrLf & vbCrLf
  
  sText = sText & "- If the mouse is currently outside the client area of the RichEdit" & vbCrLf & _
                           "  control, Shift+F10 displays the context menu 10 pixels below" & vbCrLf & _
                           "  and to the right of the current caret position (insertion point)." & vbCrLf & vbCrLf

  sText = sText & "WordBreakProc experiment:" & vbCrLf & _
                          "   double-click on the follwing values:  &HFFFF  -1234"
  
  GetIntroText = sText
  
End Function

Private Sub Form_Resize()
  MoveWindow m_hwndEdit, 0, 0, ScaleWidth, ScaleHeight, True
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Set Form1 = Nothing
  End
End Sub

' Allows Shift+F10 to show context menu and adds some
' interesting functionality...

' If the mouse pos is outside of Rich1's client area, fill ptCursor
' w/ Rich1's current caret pos & have the context menu popup
' 10 pixels to the right & below the end of the current selection

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  Dim ptCursor As POINTAPI, rctRich1 As RECT
  Dim chCharPos As CHARRANGE
  
  If Shift = vbShiftMask And KeyCode = vbKeyF10 Then
    ' Get the mouse pos w/ respect to Rich1's client area.
    ' Fails on NT: "The calling process must have WINSTA_READATTRIBUTES
    '  access to the window station." ptCursor will be 0, 0
    GetCursorPos ptCursor   ' screen coords
    ScreenToClient m_hwndEdit, ptCursor
    
    ' Get Rich1's client coords
    GetClientRect m_hwndEdit, rctRich1
    
    If PtInRect(rctRich1, ptCursor.x, ptCursor.y) = False Then
      ' The cursor is outside of Rich1's client area,
      ' get Rich1's caret position (current insertion point):
      
      ' Scroll caret into view
      SendMessage m_hwndEdit, EM_SCROLLCARET, 0, 0
      ' Get Rich1's current selection
      SendMessage m_hwndEdit, EM_EXGETSEL, 0, chCharPos   ' no rtn val
      With chCharPos
        If .cpMax < .cpMin Then .cpMax = .cpMin   ' test for reverse selection
        ' EM_POSFROMCHAR fills the Point struct w/ the UPPER-LEFT corner of the char.
        SendMessage m_hwndEdit, EM_POSFROMCHAR, ptCursor, ByVal .cpMax   ' client coords
      End With
      ' Add some pixels for visibilty
      With ptCursor: .x = .x + 10: .y = .y + 10: End With
    End If
    
    SetEditMenuItemText True
    ' Show the context menu
    ' Execution stops here until context menu is hidden, invokes mnuEdit_Click()
    PopupMenu mnuEdit, , ptCursor.x, ptCursor.y   ' client coords
    SetEditMenuItemText False
  End If

End Sub

' Rich1 sets capture w/ a double-click word selection...??!!
' Produces the following ugly results:
' A left-click anywhere on the screen will activate Rich1
' A right-click anywhere on the screen will show the context menu,
' It releases it for a context menu right-click but not for a shortcut keystroke

Private Sub Rich1_DblClick()
  ReleaseCapture
  tmrWordBreakProc = True   ' an experiment...
End Sub

Private Sub Rich1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  ' Show right-click context menu
  If Button = vbRightButton Then
    SetEditMenuItemText True
    ' Execution stops here until context menu is hidden.
    ' (TrackPopupMenu() behaves identically!)
    PopupMenu mnuEdit   ' Invokes mnuEdit_Click()
    SetEditMenuItemText False
  End If
End Sub

' To change menu command text, this proc must
' be called BEFORE the Edit menu is displayed.
' Will fail miserably if executed when menu IS displayed!!
' Called right before & right after context menu is displayed
' in Form_KeyDown() (Shift+F10) & Rich1_MouseUp()

Private Sub SetEditMenuItemText(bIsContext As Boolean)

  mnuEditUndo.Caption = "&Undo" & IIf(bIsContext, "", vbTab & "Ctrl+Z")
  mnuEditCut.Caption = "Cu&t" & IIf(bIsContext, "", vbTab & "Ctrl+X")
  mnuEditCopy.Caption = "&Copy" & IIf(bIsContext, "", vbTab & "Ctrl+C")
  mnuEditPaste.Caption = "&Paste" & IIf(bIsContext, "", vbTab & "Ctrl+V")
  mnuEditDelete.Caption = "&Delete" & IIf(bIsContext, "", vbTab & "Del")
  mnuEditSelAll.Caption = "Select &All" & IIf(bIsContext, "", vbTab & "Ctrl+A")

End Sub

' >> The Edit menu is already displayed before this code is executed !!! <<

Private Sub mnuEdit_Click()
  EnableEditMenuItems
End Sub

' The Rich ctrl processes edit accelerator keys but does
' not display a corresponding right-click edit context menu (?)
' So NO shortcut keys are defined for the following cmds:
' Undo, Cut, Copy, Paste, Delete & Select All.
' Allows their respective shortcut key strings to be added
' & remove appropriately by mnuEdit_Click() above.
' Their corresponding click events below are called only from
' their respective menu item cmds (not from accelerators).
' The Enabled property is the menu's default property & is either True or False.
' Happens after menu is displayed!

Private Sub EnableEditMenuItems()

  Dim CR As CHARRANGE, dwTxtLen As Long
  
  ' Fill CR w/ current selection range
  SendMessage m_hwndEdit, EM_EXGETSEL, 0, CR
  
  ' Undo:
  mnuEditUndo = SendMessage(m_hwndEdit, EM_CANUNDO, 0, 0)
  
  ' Cut, Copy & Delete: enable if a selection, disable if no selection
  mnuEditCut = (CR.cpMin < CR.cpMax)
  mnuEditCopy = (CR.cpMin < CR.cpMax)
  mnuEditDelete = (CR.cpMin < CR.cpMax)
  
  ' Paste: enable of clipboard text, disable if not
  mnuEditPaste = Len(Clipboard.GetText)
  
  ' Select All: disable if everything's already selected, enable otherwise.
  ' The Rich ctrl ALWAYS has a CrLf at the end of it's contents
  ' which is not seen by WM_GETTEXTLENGTH.
  dwTxtLen = SendMessage(m_hwndEdit, WM_GETTEXTLENGTH, 0, 0)
  mnuEditSelAll = Not (CR.cpMin = 0 And CR.cpMax = dwTxtLen + 2&)

'Debug.Print "TxtLen: "; SendMessage(m_hwndEdit, WM_GETTEXTLENGTH, 0, 0)
'Debug.Print "CR.cpMin: " & CR.cpMin
'Debug.Print "CR.cpMax: " & CR.cpMax

End Sub

Private Sub mnuEditUndo_Click()   ' Ctrl+Z
  SendMessage m_hwndEdit, EM_UNDO, 0, 0
End Sub

Private Sub mnuEditCut_Click()   ' Ctrl+X
  SendMessage m_hwndEdit, WM_CUT, 0, 0
End Sub

Private Sub mnuEditCopy_Click()   ' Ctrl+C
  SendMessage m_hwndEdit, WM_COPY, 0, 0
End Sub

Private Sub mnuEditPaste_Click()   ' Ctrl+V
  SendMessage m_hwndEdit, WM_PASTE, 0, 0
End Sub

Private Sub mnuEditDelete_Click()   ' Del
  SendMessage m_hwndEdit, WM_CLEAR, 0, 0
End Sub

Private Sub mnuEditSelAll_Click()   ' Ctrl+A
  Dim CR As CHARRANGE
  CR.cpMin = 0: CR.cpMax = -1
  SendMessage m_hwndEdit, EM_EXSETSEL, 0, CR
End Sub

' This was an experiment w/ extended char selection...
' Timer is enabled in Rich1_DblClick()

' If the selection from a double-click is dec or hex, see if
' the prev char is "-" or "&". If present, select the char.

Private Sub tmrWordBreakProc_Timer()  ' Enabled = False, Interval = 1
  
  Dim crCurSel As CHARRANGE
  Dim trNewSel As TEXTRANGE
  On Error GoTo Out
  tmrWordBreakProc = False   ' turns itself offf
  
  ' Get the current selection
  SendMessage m_hwndEdit, EM_EXGETSEL, 0, crCurSel
  
  ' If the start pos of the current selection isn't
  ' passed the 1st char in Rich1, out-o-here
  If crCurSel.cpMin = 0 Then Exit Sub
  
  ' Append the prev char to the current selection
  trNewSel.chrg = crCurSel
  With trNewSel.chrg
    .cpMin = .cpMin - 1
    ' Allocate 1 more pos for the null char
    trNewSel.lpstrText = String$((.cpMax - .cpMin) + 1, 0)
  End With
  SendMessage m_hwndEdit, EM_GETTEXTRANGE, 0, trNewSel
  
  ' If the 1st char of the new selection isn't
  ' a "-" or "&", time to leave
  If InStr("-&", Left$(trNewSel.lpstrText, 1)) = 0 Then Exit Sub
  
  ' GetDecVal() generates an error if it's
  ' passed arg can't be converted to a Long
  GetDecVal Left$(trNewSel.lpstrText, InStr(trNewSel.lpstrText, vbNullChar) - 1)
  
  ' GetDecVal() didn't cause an error above, keep going.
  ' Hide what's happening
  SendMessage m_hwndEdit, WM_SETREDRAW, ByVal 0, 0
  
  ' Select the prev char into the current selection
  SendMessage m_hwndEdit, EM_EXSETSEL, 0, trNewSel.chrg
  
  ' Turn painting back on & refresh
  SendMessage m_hwndEdit, WM_SETREDRAW, ByVal 1, 0
  InvalidateRect m_hwndEdit, 0, True
  
Out:
End Sub

' Returns decimal value if sInput is a valid value, rtns 0 if not

' CLng() generates a "Type is mismatch" (Error 13) if
' it's arg. can't be converted to a numeric expression
' OR an "Overflow" (Error 6) if the value lies outside of
' the Long data type (> 2147483647 or < -2147483648)
' >> It's up to the calling proc to handle the Error !!! <<

Private Function GetDecVal(ByVal sInput As String) As Long

  ' Valid hex prefixes are: "0x", "0X", "&h" & "&H"
  If InStr(1, sInput, "0x", 1) = 1 Or InStr(1, sInput, "&H", 1) = 1 Then
    GetDecVal = CLng("&H" & Right$(sInput, Len(sInput) - 2))
  Else
    GetDecVal = CLng(sInput)
  End If

End Function
