VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "Comctl32.ocx"
Begin VB.Form Form1 
   Caption         =   "Special Folders Path Sample Project"
   ClientHeight    =   3960
   ClientLeft      =   1050
   ClientTop       =   1620
   ClientWidth     =   9735
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3960
   ScaleWidth      =   9735
   StartUpPosition =   2  'CenterScreen
   Begin ComctlLib.ListView lvSpecialFolderList 
      Height          =   3375
      Left            =   0
      TabIndex        =   1
      Top             =   480
      Width           =   9735
      _ExtentX        =   17171
      _ExtentY        =   5953
      View            =   3
      Sorted          =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.Label lblInstructions 
      Caption         =   "Click on a folder name to display the path"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   120
      Width           =   3615
   End
   Begin VB.Label lblPath 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   3720
      TabIndex        =   0
      Top             =   120
      Width           =   45
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 1

Private Declare Function SHGetSpecialFolderLocation Lib "shell32" _
                     (ByVal hwnd As Long, _
                     ByVal nFolder As Long, _
                     Pidl As Long) As Long
' This function retrieves the PIDL of a special folder. This function returns NOERROR
' if successful, or an OLE-defined error result otherwise. The function requires the
' following parameters:
'
'     hwnd- long handle to the owner window the client should specify if it displays a
'           dialog box or message box. Use zero for this value
'     nFolder- long constant that specifies the special folder. The constant values are
'              the index numbers of the Special folders combo box.
'     Pidl-    a pointer to the pointer of the special folder.

Private Declare Function SHGetPathFromIDList Lib "shell32" _
                     (Pidl As Long, _
                     ByVal FolderPath As String) As Long
' This function converts an item identifier list to a file system path. The function
' returns TRUE if successful, or FALSE otherwise. The function requires the following
' parameters:
'
'     Pidl-       a pointer to the pointer of the special folder
'     FolderPath- a string buffer to receive the file system path. This buffer contains
'                 the directory path.

Private Declare Function SHGetMalloc Lib "shell32" (lpMalloc As ITMalloc) As Long
' This function is used to free the memory allocated by the SHGetSpecialFolderLocation
' and the SHGetPathFromIDList functions. This function requires a pointer to the
' Free method of the IMalloc operating system object. To expose this method to
' Visual Basic, you need a reference to the ITMalloc .tlb type library enclosed with this
' sample project.

'User-defined type to store special folder information.
Private Type FolderData
   sName As String
   sConstant As String
   sValue As String
   sNotes As String
End Type


Private Sub Form_Load()

   Dim liListItem As ListItem
   Dim sAllOS As String
   Dim sWinNT As String
   Dim sIE40 As String
   Dim sVFolder As String
   
   sAllOS = "Windows NT and Windows 95"
   sWinNT = "Windows NT only"
   sIE40 = "Internet Explorer only"
   sVFolder = "Virtual Folder"
   
   With lvSpecialFolderList
      .ColumnHeaders.Add , , "Special Folder", 2100
      .ColumnHeaders.Add , , "Constant Name", 3000
      .ColumnHeaders.Add , , "Value", 500, vbCenter
      .ColumnHeaders.Add , , "Operating Systems", 2500
   End With
   
   Dim sFolderData(29) As FolderData
   Dim iCounter As Integer
   
   ' File system directory that contains the for the common program groups that
   ' appear on the Start menu for all users.
   With sFolderData(1)
      .sName = "Program Group-All Users"
      .sConstant = "CSIDL_DESKTOP"
      .sValue = 0
      .sNotes = sAllOS
   End With
   
   ' Windows Desktop
   With sFolderData(2)
      .sName = "Windows Desktop"
      .sConstant = "CSIDL_PROGRAMS"
      .sValue = 2
      .sNotes = sWinNT
   End With
   
   ' Virtual folder containing icons for the Control Panel programs.
   With sFolderData(3)
      .sName = "Control Panel Programs"
      .sConstant = "CSIDL_CONTROLS"
      .sValue = 3
      .sNotes = sVFolder
   End With
         
   ' Virtual folder containing installed printers.
   With sFolderData(4)
      .sName = "Printers"
      .sConstant = "CSIDL_PRINTERS"
      .sValue = 4
      .sNotes = sVFolder
   End With
      
   ' File system directory that serves as a common repository for documents.
   With sFolderData(5)
      .sName = "Personal Documents"
      .sConstant = "CSIDL_PERSONAL"
      .sValue = 5
      .sNotes = sAllOS
   End With

   ' File system directory that serves as a common repository for the user's
   ' favorite items.
   With sFolderData(6)
      .sName = "Favorites Folder"
      .sConstant = "CSIDL_FAVORITES"
      .sValue = 6
      .sNotes = sAllOS
   End With
   
   ' File system direcotry that corresponds to the user's Startup program group.
   ' The system starts these programs whenever any user logs onto Windows NT or
   ' starts Windows 95.
   With sFolderData(7)
      .sName = "Start Up Folder-User"
      .sConstant = "CSIDL_STARTUP"
      .sValue = 7
      .sNotes = sWinNT
   End With
      
   ' File system directory that contains the user's most recently used documents.
   With sFolderData(8)
      .sName = "Recently Used Documents"
      .sConstant = "CSIDL_RECENT"
      .sValue = 8
      .sNotes = sAllOS
   End With
   
   ' File system direcotry that contains Sent To Menu items.
   With sFolderData(9)
      .sName = "Send To Menu Items"
      .sConstant = "CSIDL_SENDTO"
      .sValue = 9
      .sNotes = sAllOS
   End With
                                             
   ' File system directory containing file objects in the user's Recycle Bin.
   ' The location of this directory is not in the registry; the directory is marked
   ' with hidden and system attributes to prevent the user from moving the directory.
   With sFolderData(10)
      .sName = "Recycle Bin"
      .sConstant = "CSIDL_BITBUCKET"     '
      .sValue = 10
      .sNotes = "Hidden Folder."
   End With
   
   ' File system directory containing Start menu items unique to the user.
   With sFolderData(11)
      .sName = "Start Menu-User"
      .sConstant = "CSIDL_STARTMENU"
      .sValue = 11
      .sNotes = sWinNT
   End With
   
   ' File system directory used to physically store file objects on the desktop. This
   ' directory should not be confused wiht the desktop folder itself.
   With sFolderData(12)
      .sName = "Desktop Directory-User"
      .sConstant = "CSIDL_DESKTOPDIRECTORY"
      .sValue = 16
      .sNotes = sWinNT
   End With
   
   ' Virtual folder containing everything on the local computer such as storage devices,
   ' printers, and Control Panel. The folder may also contain mapped network drives.
   With sFolderData(13)
      .sName = "My Computer Icon"
      .sConstant = "CSIDL_DRIVES"
      .sValue = 17
      .sNotes = sVFolder
   End With
   
   ' Virtual folder representing the top level of the network hierarchy.
   With sFolderData(14)
      .sName = "Network Neighborhood Icon"
      .sConstant = "CSIDL_NETWORK"
      .sValue = 18
      .sNotes = sVFolder
   End With
      
   ' File system direcotry containing objects that appear in the network neighborhood.
   With sFolderData(15)
      .sName = "Network Neighborhood Objects"
      .sConstant = "CSIDL_NETHOOD"
      .sValue = 19
      .sNotes = sWinNT
   End With
   
   ' Virtual folder containing fonts.
   With sFolderData(16)
      .sName = "Fonts Folder"
      .sConstant = "CSIDL_FONTS"
      .sValue = 20
      .sNotes = sVFolder
   End With
   
   ' File system directory that serves as a common repository for document templates.
   With sFolderData(17)
      .sName = "Templates Folder"
      .sConstant = "CSIDL_TEMPLATES"
      .sValue = 21
      .sNotes = sAllOS
   End With
   
   ' File system directory that contains the programs and folders that appear on the
   ' Start menu for all users.
   With sFolderData(18)
      .sName = "Start Menu-Common"
      .sConstant = "CSIDL_COMMON_STARTMENU"
      .sValue = 22
      .sNotes = sAllOS
   End With
   
   ' File system directory that contains the directories for the common program groups that
   ' appear on the Start menu for all users.
   With sFolderData(19)
      .sName = "Program Menu-All Users"
      .sConstant = "CSIDL_COMMON_PROGRAMS"
      .sValue = 23
      .sNotes = sAllOS
   End With
   
   ' File system directory that contains the programs that appear in the Startup folder for
   ' all users.
   With sFolderData(20)
      .sName = "Start Up Folder-Common"
      .sConstant = "CSIDL_COMMON_STARTUP"
      .sValue = 24
      .sNotes = sAllOS
   End With
   
   ' File system directory that contains files and folders that appear on the desktop for
   ' all users.
   With sFolderData(21)
      .sName = "Desktop Directory-Common"
      .sConstant = "CSIDL_COMMON_DESKTOPDIRECTORY"
      .sValue = 25
      .sNotes = sAllOS
   End With
                                             
   ' File system directory that serves as a common repository for application-specific data.
   With sFolderData(22)
      .sName = "Application Specific Data"
      .sConstant = "CSIDL_APPDATA"
      .sValue = 26
      .sNotes = sWinNT
   End With
   
   ' File system directory that serves as a common repository for printer links.
   With sFolderData(23)
      .sName = "Printer Links"
      .sConstant = "CSIDL_PRINTHOOD"
      .sValue = 27
      .sNotes = sWinNT
   End With
   
   ' File system directory that corresponds to the user's nonlocalized Startup
   ' program group.
   With sFolderData(24)
      .sName = "User's Startup Group"
      .sConstant = "CSIDL-ALTSTARTUP"
      .sValue = 29
      .sNotes = sIE40
   End With
   
   ' File system directory that corresponds to the nonlocalized Startup program
   ' group for all users.
   With sFolderData(25)
      .sName = "Common Startup Group"
      .sConstant = "CSIDL_COMMON_ALTSTARTUP"
      .sValue = 30
      .sNotes = sIE40
   End With
   
   ' File system directory that serves as a common repository for all users' favorite items.
   With sFolderData(26)
      .sName = "Common Favorites"
      .sConstant = "CISDL_COMMON_FAVORITES"
      .sValue = 31
      .sNotes = sIE40
   End With
   
   ' File system directory that serves as a common repository for temporary Internet files.
   With sFolderData(27)
      .sName = "Internet Files-Temporary"
      .sConstant = "CSIDL_INTERNET_CACHE"
      .sValue = 32
      .sNotes = sIE40
   End With
   
   ' File system directory that serves as a common repository for Internet cookies.
   With sFolderData(28)
      .sName = "Cookies"
      .sConstant = "CSIDL_COOKIES"
      .sValue = 33
      .sNotes = sIE40
   End With
   
   ' File system directory that serves as a common repository for Internet history items.
   With sFolderData(29)
      .sName = "History Folder"
      .sConstant = "CSIDL_HISTORY"
      .sValue = 34
      .sNotes = sIE40
   End With
   
   For iCounter = LBound(sFolderData) To UBound(sFolderData)
      With lvSpecialFolderList.ListItems
         Set liListItem = .Add(, , sFolderData(iCounter).sName)
            With liListItem
               .SubItems(1) = CStr(sFolderData(iCounter).sConstant)
               .SubItems(2) = sFolderData(iCounter).sValue
               .SubItems(3) = sFolderData(iCounter).sNotes
            End With
      End With
   Next
End Sub


Private Sub lvSpecialFolderList_Click()
   Dim hResult As Long
   Dim bResult As Long
   Dim Pidl As Long
   Dim ShellMalloc As ITMalloc
   Dim FolderPath As String * 300
     
   hResult = SHGetSpecialFolderLocation(0, _
                                       lvSpecialFolderList.SelectedItem.SubItems(2), _
                                       Pidl)
   lblPath.ForeColor = vbBlack
   
   If hResult = 0 Then
      'SHGetPathFromIDList only works with special folders that exist on a hard drive
      'For example, "CSIDL_DRIVES" means "My Computer" which is not a folder on any drive
      'Windows NT has a different set of special folders than Windows 95
      bResult = SHGetPathFromIDList(ByVal Pidl, FolderPath)
    
      hResult = SHGetMalloc(ShellMalloc)
      ShellMalloc.Free Pidl
      Set ShellMalloc = Nothing
      
      If bResult = 1 Then
        lblPath.Caption = "Path is " & FolderPath
      Else
        lblPath.ForeColor = vbRed
        lblPath.Caption = "SHGetPathFromIDList Failed"
      End If
   Else
      lblPath.ForeColor = vbRed
      lblPath.Caption = "SHGetSpecialFolderLocation Failed"
   End If
End Sub
