VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SimpleArray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' -------------------------------------------------------------------
' | VB CGI Module v1.12 SimpleArray Component                       |
' | Copyright (C) 1998-99 Aran Meuser                               |
' | All Rights Reserved                                             |
' |                                                                 |
' | WWW Address: www.northcoast.com/~aran/                          |
' | E-Mail Address: aran@northcoast.com                             |
' -------------------------------------------------------------------
Option Explicit

Public Count As Integer

Private i As Integer
Private j As Integer
Private Keys() As String
Private Items() As Variant
Private Tags() As String

Public Function ParseTHTML( _
    strTHTML As String _
) As String
    Dim i As Integer
    Dim inCom As Boolean
    Dim thisCom As String

    For i = 1 To Len(strTHTML)
        If Mid(strTHTML, i, 2) = "%%" Then
            inCom = Not inCom
            If Not inCom Then
                ParseTHTML = ParseTHTML & Me(thisCom)
                thisCom = ""
            End If
            i = i + 1
        ElseIf inCom = True Then
            thisCom = thisCom & Mid(strTHTML, i, 1)
        Else
            ParseTHTML = ParseTHTML & Mid(strTHTML, i, 1)
        End If
    Next i
End Function

Public Sub Add( _
    Item As Variant, _
    Optional Key As String, _
    Optional Tag As String, _
    Optional ItemIndex As Integer = 0 _
)
    Count = Count + 1
    ReDim Preserve Items(1 To Count)
    ReDim Preserve Keys(1 To Count)
    ReDim Preserve Tags(1 To Count)
    
    If ItemIndex > 0 Then
        If ItemIndex > Count Then Exit Sub
        
        For i = Count To ItemIndex Step -1
            If i = ItemIndex Then
                Items(i) = Item
                Keys(i) = Key
                Tags(i) = Tag
            Else
                Items(i) = Items(i - 1)
                Keys(i) = Keys(i - 1)
                Tags(i) = Tags(i - 1)
            End If
        Next i
    Else
        Items(Count) = 0
        If VarType(Item) = vbObject Or _
        VarType(Item) = vbEmpty Then
            Set Items(Count) = Item
        Else
            Items(Count) = Item
        End If
        Keys(Count) = Key
        Tags(Count) = Tag
    End If
End Sub

Property Get Item(ByVal IndexOrKey As Variant) As Variant
Attribute Item.VB_UserMemId = 0
    If Count = 0 Then Exit Property
    
    If VarType(IndexOrKey) = vbString Then
        j = -1
        For i = 1 To Count
            If LCase(IndexOrKey) = LCase(Keys(i)) Then
                j = 1
                IndexOrKey = i
                Exit For
            End If
        Next i
        If j = -1 Then
            Exit Property
        End If
    Else
        If IndexOrKey > Count Or IndexOrKey < 1 Then
            Exit Property
        End If
    End If
    
    If VarType(Items(IndexOrKey)) = vbObject Or _
    VarType(Items(IndexOrKey)) = vbEmpty Then
        Set Item = Items(IndexOrKey)
    Else
        Item = Items(IndexOrKey)
    End If
End Property

Property Get Key(ByVal IndexOrKey As Variant) As String
    If Count = 0 Then Exit Property
    
    If VarType(IndexOrKey) = vbString Then
        j = -1
        For i = 1 To Count
            If LCase(IndexOrKey) = LCase(Keys(i)) Then
                j = 1
                IndexOrKey = i
                Exit For
            End If
        Next i
        If j = -1 Then
            Exit Property
        End If
    Else
        If IndexOrKey > Count Or IndexOrKey < 1 Then
            Exit Property
        End If
    End If
    
    Key = Keys(IndexOrKey)
End Property

Property Let Item(ByVal IndexOrKey As Variant, ByVal ItemVal As Variant)
    If Count = 0 Then Exit Property
    
    If VarType(IndexOrKey) = vbString Then
        j = -1
        For i = 1 To Count
            If LCase(IndexOrKey) = LCase(Keys(i)) Then
                j = 1
                IndexOrKey = i
                Exit For
            End If
        Next i
        If j = -1 Then
            Exit Property
        End If
    Else
        If IndexOrKey > Count Or IndexOrKey < 1 Then
            Exit Property
        End If
    End If
    
    Items(IndexOrKey) = ItemVal
End Property

Property Let Key(ByVal IndexOrKey As Variant, ByVal KeyVal As String)
    If Count = 0 Then Exit Property
    
    If VarType(IndexOrKey) = vbString Then
        j = -1
        For i = 1 To Count
            If LCase(IndexOrKey) = LCase(Keys(i)) Then
                j = 1
                IndexOrKey = i
                Exit For
            End If
        Next i
        If j = -1 Then
            Exit Property
        End If
    Else
        If IndexOrKey > Count Or IndexOrKey < 1 Then
            Exit Property
        End If
    End If
    
    Keys(IndexOrKey) = KeyVal
End Property

Property Get Tag(ByVal IndexOrKey As Variant) As String
    If Count = 0 Then Exit Property
    
    If VarType(IndexOrKey) = vbString Then
        j = -1
        For i = 1 To Count
            If LCase(IndexOrKey) = LCase(Keys(i)) Then
                j = 1
                IndexOrKey = i
                Exit For
            End If
        Next i
        If j = -1 Then
            Exit Property
        End If
    Else
        If IndexOrKey > Count Or IndexOrKey < 1 Then
            Exit Property
        End If
    End If
    
    Tag = Tags(IndexOrKey)
End Property

Property Let Tag(ByVal IndexOrKey As Variant, ByVal TagVal As String)
    If Count = 0 Then Exit Property
    
    If VarType(IndexOrKey) = vbString Then
        j = -1
        For i = 1 To Count
            If LCase(IndexOrKey) = LCase(Keys(i)) Then
                j = 1
                IndexOrKey = i
                Exit For
            End If
        Next i
        If j = -1 Then
            Exit Property
        End If
    Else
        If IndexOrKey > Count Or IndexOrKey < 1 Then
            Exit Property
        End If
    End If
    
    Tags(IndexOrKey) = TagVal
End Property


Public Sub Move( _
    FromIndex As Integer, _
    ToIndex As Integer _
)
    If Count < 2 Then Exit Sub
    
    Dim StepVal As Integer
    Dim FromItem As Variant
    Dim FromKey As String
    Dim FromTag As String

    If FromIndex > Count Or FromIndex < 1 Or _
    ToIndex > Count Or ToIndex < 1 Then
        Exit Sub
    End If

    FromItem = Items(FromIndex)
    FromKey = Keys(FromIndex)
    FromTag = Tags(FromIndex)
    If FromIndex < ToIndex Then
        StepVal = 1
    ElseIf FromIndex > ToIndex Then
        StepVal = -1
    Else
        Exit Sub
    End If

    For i = FromIndex To ToIndex Step StepVal
        If i = ToIndex Then
            Items(i) = FromItem
            Keys(i) = FromKey
            Tags(i) = FromTag
        Else
            Items(i) = Items(i + StepVal)
            Keys(i) = Keys(i + StepVal)
            Tags(i) = Tags(i + StepVal)
        End If
    Next i
End Sub
Public Sub Remove( _
    IndexOrKey As Variant _
)
    If Count = 0 Then Exit Sub
    
    If VarType(IndexOrKey) = vbString Then
        j = -1
        For i = 1 To Count
            If LCase(IndexOrKey) = LCase(Keys(i)) Then
                j = 1
                IndexOrKey = i
                Exit For
            End If
        Next i
        If j = -1 Then
            Exit Sub
        End If
    Else
        If IndexOrKey > Count Or IndexOrKey < 1 Then
            Exit Sub
        End If
    End If
    
    For i = IndexOrKey To Count - 1
        Set Items(i) = Items(i + 1)
        Keys(i) = Keys(i + 1)
        Tags(i) = Tags(i + 1)
    Next i
    Count = Count - 1
    If Count > 0 Then
        ReDim Preserve Items(1 To Count)
        ReDim Preserve Keys(1 To Count)
        ReDim Preserve Tags(1 To Count)
    End If
End Sub
Public Function Search( _
    SrchVal As Variant _
) As Integer
    If Count = 0 Then Exit Function
    
    Search = 0
    For i = 1 To Count
        If Items(i) = SrchVal Then
            Search = i
            Exit For
        End If
    Next i
End Function
Public Sub Sort( _
    Optional reverse As Boolean = False _
)
    If Count = 0 Then Exit Sub

    For i = 2 To Count
        For j = i - 1 To 1 Step -1
            If reverse Then
                If Keys(i) < Keys(j) Then
                    Move i, j + 1
                    Exit For
                End If
            Else
                If Keys(i) > Keys(j) Then
                    Move i, j + 1
                    Exit For
                End If
            End If
            If j = 1 Then
                Move i, 1
            End If
        Next j
    Next i
End Sub


